# openforcefield.typing.engines.smirnoff.parameters.ParameterList

class `openforcefield.typing.engines.smirnoff.parameters.``ParameterList`(input_parameter_list=None)

  Parameter list that also supports accessing items by SMARTS string.

  Warning

  This API is experimental and subject to change.

  Methods

  `append`(parameter) | Add a ParameterType object to the end of the ParameterList
  `clear`() |
  `copy`() |
  `count`(value) |
  `extend`(other) | Add a ParameterList object to the end of the ParameterList
  `index`(item) | Get the numerical index of a ParameterType object or SMIRKS in this ParameterList.
  `insert`(index, parameter) | Add a ParameterType object as if this were a list
  `pop`([index]) | Raises IndexError if list is empty or index is out of range.
  `remove`(value) | Raises ValueError if the value is not present.
  `reverse` | L.reverse() – reverse IN PLACE
  `sort`([key, reverse]) |
  `to_list`([return_cosmetic_attributes]) | Render this ParameterList to a normal list, serializing each ParameterType-derived object in it to dict.

  `__init__`(input_parameter_list=None)

    Initialize a new ParameterList, optionally providing a list of ParameterType objects to initially populate it.

    Parameters
      input_parameter_list: list[ParameterType], default=None

        A pre-existing list of ParameterType-based objects. If None, this ParameterList will be initialized empty.

  Methods

  `__init__`([input_parameter_list]) | Initialize a new ParameterList, optionally providing a list of ParameterType objects to initially populate it.
  `append`(parameter) | Add a ParameterType object to the end of the ParameterList
  `clear`() |
  `copy`() |
  `count`(value) |
  `extend`(other) | Add a ParameterList object to the end of the ParameterList
  `index`(item) | Get the numerical index of a ParameterType object or SMIRKS in this ParameterList.
  `insert`(index, parameter) | Add a ParameterType object as if this were a list
  `pop`([index]) | Raises IndexError if list is empty or index is out of range.
  `remove`(value) | Raises ValueError if the value is not present.
  `reverse` | L.reverse() – reverse IN PLACE
  `sort`([key, reverse]) |
  `to_list`([return_cosmetic_attributes]) | Render this ParameterList to a normal list, serializing each ParameterType-derived object in it to dict.

  `append`(parameter)

    Add a ParameterType object to the end of the ParameterList

    Parameters
      parameter a ParameterType-derived object
  `extend`(other)

    Add a ParameterList object to the end of the ParameterList

    Parameters
      other a ParameterList
  `index`(item)

    Get the numerical index of a ParameterType object or SMIRKS in this ParameterList. Raises ValueError if the item is not found.

    Parameters
      item ParameterType-derived object or str

        The parameter or SMIRKS to look up in this ParameterList

    Returns
      index int

        The index of the found item

  `insert`(index, parameter)

    Add a ParameterType object as if this were a list

    Parameters
      index int

        The numerical position to insert the parameter at

      parameter a ParameterType-derived object

        The parameter to insert

  `to_list`(return_cosmetic_attributes=False)

    Render this ParameterList to a normal list, serializing each ParameterType-derived object in it to dict.

    Parameters
      return_cosmetic_attributes bool, optional. default = False

        Whether to return non-spec attributes of each ParameterType-derived object.

    Returns
      parameter_list List[dict]

        A serialized representation of a ParameterList, with each ParameterType it contains converted to dict.

  `clear`() → None -- remove all items from L
  `copy`() → list -- a shallow copy of L
  `count`(value) → integer -- return number of occurrences of value
  `pop`([index]) → item -- remove and return item at index (default last).

    Raises IndexError if list is empty or index is out of range.

  `remove`(value) → None -- remove first occurrence of value.

    Raises ValueError if the value is not present.

  `reverse`()

    L.reverse() – reverse IN PLACE

  `sort`(key=None, reverse=False) → None -- stable sort *IN PLACE*